-------------------------------------------------------------------------------
---------------------------      21.EX       ----------------------------------
-------------------------------------------------------------------------------
----       A Twenty-Ones card game to show off DEALER.EX (EuDealer!)       ----
-------------------------------------------------------------------------------
--                    Created By THE REAPER  (J. Lays)                       --
-------------------------------------------------------------------------------
--<  Send Comments, Bugs, Musings, and Christmas Lists (wait a second...)   >--
---------------------<  -to-  reaper@auracom.com  >----------------------------
-------------------------------------------------------------------------------
--POINT OF GAME: |                                                           --
------------------                                                           --
--      It's just you and the dealer in the fast-paced (depending on your    --
-- computer) card game of Twenty-Ones.  Similiar (well, pretty much the exact--
-- same) as Black Jack, you have to get as close to twenty-one as possible   --
-- without going over (BUST!!!). However your oppenent, He Who Shuffles(tm), --
-- is trying to do the exact same, and which ever of you get higher wins!    --
-- Also, if you can get five cards without going over, you win no matter what--
-- the other guy has. Lets draw some cards!!!!!!!                            --
-------------------------------------------------------------------------------
--HOW TO PLAY: |                                                             --
----------------                                                             --
--      As a hand starts, you and He Who Shuffles(tm) gets two cards. Your   --
-- total is how much your cards add up to be. Any face card is worth 10, and --
-- a ace is worth either 1 or 11 depending on what suits you best. If you    --
-- want another card, either hit SPACE (keyboard) or click the stack of cards--
-- with the mouse (if you have one). You can keep getting cards (HITs) until --
-- you have five cards or you BUST (getting over 21, which is not good). When--
-- you want to STICK with what you got, hit ENTER (keyboard) or click one of --
-- your cards with the mouse.  HWS(tm) will show you what he got, and you    --
-- will see who won. To start a new hand, hit SPACE or click the stack. To   --
-- quit the game (why would you do that, silly person?), hit ESC. See ya!    --
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
without warning
without type_check
include graphics.e
include mouse.e
include machine.e
include dealer.e  --That's My File!!!!!!!!!!!!!!!!!!!!!!!(okay, enough of that)

atom mouse,mstat,game,aces,faces,extra,comstick,DEAL,STICK,HIT,pwin,plose,mode
sequence deck,deckloc,Cursors,plcards,comcards,mloc,action
object spare
constant loop=1,SPACE=32,ENTER=13,ESC=27,
	 cardloc={{50,300},{120,300},{190,300},{260,300},{330,300}},
	 comcardloc={{50,100},{120,100},{190,100},{260,100},{330,100}},
	 deckxy={50,200},textxy={30,1},winxy={30,50},losexy={30,65}
	 
Cursors=    --Initialize the mouse cursor variables (or something like that)
    {{
	#FF,#FF,#FF,#F3,#FF,#E1,#FF,#E1,#FF,#E1,#FF,#E1,#07,#E0,#00,#E0,
	#00,#80,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#01,#80,#03,#C0,
	#00,#00,#00,#0C,#00,#12,#00,#12,#00,#12,#B0,#13,#4E,#12,#49,#12,
	#49,#72,#49,#92,#01,#90,#01,#80,#01,#80,#01,#80,#02,#40,#FC,#3F}, 5, 0,
    {
	#FF,#3F,#FF,#1F,#FF,#0F,#FF,#07,#FF,#03,#FF,#01,#FF,#00,#7F,#00,
	#3F,#00,#1F,#00,#0F,#00,#07,#00,#47,#18,#7F,#38,#3F,#FC,#7F,#FE,
	#00,#00,#00,#40,#00,#60,#00,#70,#00,#78,#00,#7C,#00,#7E,#00,#7F,
	#80,#7F,#C0,#7F,#E0,#7F,#30,#67,#00,#43,#00,#03,#80,#01,#00,#00}, 1, 0}

------------------------------------------------------------------------------
--------------ALL PROCEDURES AND FUNCTIONS-------------------------------------
-------------------------------------------------------------------------------

--CHANGE_CURSOR()--------------------------------------------------------------

---------------Okay, what's below is actually Victor Milankovics' code from his
integer Mouse_Cursor_Store          --mousecur.e file. I incorperated into this
Mouse_Cursor_Store=allocate_low(64) --program for a cool mouse changing effect
				    --without having to put the include file
				    --into the package. (hope he doesn't mind)
procedure Change_cursor(integer CursorNo)

sequence reg_list

  reg_list=repeat(0,10)
  poke(Mouse_Cursor_Store, Cursors[(CursorNo-1)*3+1])
  reg_list[REG_AX]=#0009
  reg_list[REG_BX]=Cursors[(CursorNo-1)*3+2]
  reg_list[REG_CX]=Cursors[(CursorNo-1)*3+3]
  reg_list[REG_ES]=floor(Mouse_Cursor_Store /16)
  reg_list[REG_DX]=remainder(Mouse_Cursor_Store,16)
  reg_list=dos_interrupt(#33, reg_list)

end procedure

----------------------Okay, back to my code------------------------------------

--NEXTCARD()-------------------------------------------------------------------

function nextcard()  --a good function to have in a card game
    spare=deck[1]  --gets the top card from the deck
    
    deck=deck[2..length(deck)]  --takes that card out of the sequence
    
    return spare  --returns the top card
end function

--TALLY()----------------------------------------------------------------------

function tally(atom which)  --this adds up the cards
    aces=0
    faces=0
    extra=0
    if which=1 then  --check whether the cards are yours or He Who Shuffle's(tm)
	spare=plcards
    else
	spare=comcards
    end if
    for i = 1 to length(spare) do    --adds them up...
	if spare[i][2] = 1 then
	    aces=aces+1
	elsif spare[i][2] > 10 then
	    faces=faces+1
	else
	    extra=extra+spare[i][2]
	end if
    end for
    extra=extra+faces*10   --different for face cards (all are worth 10)
    if aces > 0 then
	for i = 1 to aces do
	    if extra < 11 then   --aces are either worth 1 or 11
		extra=extra+11
	    else
		extra=extra+1
	    end if
	end for
    end if
    return extra
end function

--SHOWCARDS()------------------------------------------------------------------

procedure showcards()      --this shows you He Who Shuffle's(tm) hidden cards
    spare=length(comcards)
    for i = 2 to spare do
	drawcard(comcardloc[i],comcards[i])
    end for
end procedure

--RESHUFFLE()------------------------------------------------------------------

procedure reshuffle()  --reshuffles the deck in a fancy looking way (kinda)
    deck=shuffle(1)
    for i = 1 to 3 do
	deckloc = showstack(deckxy,deck)
	clearstack(deckloc, BRIGHT_GREEN)
    end for
end procedure

--ENDGAME()--------------------------------------------------------------------

procedure endgame()     --take a wild guess...
    spare=graphics_mode(-1)
    abort(0)
end procedure


--DEALCARD()-------------------------------------------------------------------

procedure dealcard(atom player)   --just deals the next card...
    spare=nextcard()
    if mouse=1 then
	mouse_pointer(0)
    end if
    if player=1 then  --for the human player
	plcards=append(plcards,spare)   --add to the cards sequence
	drawcard(cardloc[length(plcards)],spare)  --then draw it out!!!
    else
	comcards=append(comcards,spare)  --this is for He Who Shuffles(tm)
	if length(comcards)=1 then
	    drawcard(comcardloc[1],spare)   --show his first card
	else
	    drawcard(comcardloc[length(comcards)],CARDBACK)
	end if
    end if
    if mouse=1 then
	mouse_pointer(1)
    end if
end procedure

--TEXTBAR()--------------------------------------------------------------------

procedure textbar()
    if mouse=1 then
	mouse_pointer(0)
    end if
    spare=sprintf("WINS : %02d",pwin)
    position(winxy[1],winxy[2])
    puts(1,spare)
    spare=sprintf("LOSSES : %02d",plose)
    position(losexy[1],losexy[2])
    puts(1,spare)
    if mouse=1 then
	mouse_pointer(1)
    end if
end procedure

--YOUWIN()---------------------------------------------------------------------

procedure youwin()    --no
    showcards()
    game=0
    position(textxy[1],textxy[2])
    puts(1,"YOU WIN!!!")
    pwin=pwin+1
    textbar()
end procedure

--YOULOSE()--------------------------------------------------------------------

procedure youlose()   --i'm not saying it
    showcards()
    game=0
    position(textxy[1],textxy[2])
    puts(1,"YOU LOSE!!")
    plose=plose+1
    textbar()
end procedure

--YOUTIE()---------------------------------------------------------------------

procedure youtie()  --i DO NOT have to tell who what these do...
    showcards()
    game=0
    position(textxy[1],textxy[2])
    puts(1,"YOU TIE!!!")
    textbar()
end procedure

--FINISH()---------------------------------------------------------------------

procedure finish()         --end of game
    if tally(1) > tally(2) then
	youwin()
    elsif tally(2) > tally(1) then
	youlose()
    else
	youtie()
    end if
end procedure

--COMPLAY()--------------------------------------------------------------------

procedure complay()  --when it's He Who Shuffle's(tm) turn...
    dealcard(2)
    if tally(2) > 21 then  --oh my, he busted
	youwin()
    end if
    if tally(2) > 16 then  -- HWS sticks on 17 or more
	comstick=1
    end if
    if length(comcards) = 5 and game = 1 then
	youlose()
    end if
end procedure

--YOUPLAY()--------------------------------------------------------------------

procedure youplay()   --your turn!!!
    dealcard(1)
    if tally(1) > 21 then   --you busted!!!!
	youlose()
    end if
    if length(plcards) = 5 and game = 1 then  --win with five cards!!!
	youwin()
    end if
end procedure

--YOUSTICK()-------------------------------------------------------------------

procedure youstick()    --What to do when you sick (opps, thats "stick")
    while comstick=0 do
	complay()
    end while
    if game=1 then
	finish()
    end if
end procedure

--HITME()----------------------------------------------------------------------

procedure hitme()    --What to do when you want another card
    youplay()
    if comstick = 0 and game = 1 then
	complay()
    end if
end procedure

--CLEANCARDS()-----------------------------------------------------------------

procedure cleancards()   --this erase all the old cards
    for i = 1 to 5 do
	clearcard(cardloc[i],10)
    end for
    for i = 1 to 5 do
	clearcard(comcardloc[i],10)
    end for
    clearstack(deckloc,10)
end procedure

--DEAL()-----------------------------------------------------------------------

procedure deal()   --man I love having simple procedure names! (deal out cards)
    game=1
    plcards={}
    comcards={}
    comstick=0
    position(textxy[1],textxy[2])
    puts(1,"          ")
    if mouse=1 then
	mouse_pointer(0)  --hide that stupid mouse!!!
    end if
	
    cleancards()
	    
    if length(deck) < 10 then  --each hand needs 10 cards left in the deck
	reshuffle()
    end if
    
    deckloc = showstack(deckxy,deck)  --shows the pile o' cards
    
    dealcard(1)  --deals your first two cards
    dealcard(1)
    dealcard(2)
    complay()
    if mouse=1 then
	mouse_pointer(1)
    end if
end procedure

--DOACTION()-------------------------------------------------------------------

procedure doaction()
    if DEAL=1 then
	deal()
    end if
    if STICK=1 then
	youstick()
    end if
    if HIT=1 then
	hitme()
    end if
end procedure

--MOVEMOUSE()------------------------------------------------------------------

procedure movemouse(sequence mloc) --checks to see if the mouse is over a card
    
    spare=0
    
    if mloc[1] > deckloc[1][1] and mloc[1] < deckloc[2][1] then
	if mloc[2] > deckloc[1][2] and mloc[2] < deckloc[2][2] then
	    spare=1
	    if mstat = 2 then     --this checks if the mouse is over the stack
		Change_cursor(1)   --(and changes the cursor)
		mstat=1
	    end if
	end if
    end if
    
    for i = 1 to length(plcards) do
	if mloc[1] > cardloc[i][1] and mloc[1] < cardloc[i][1] + 50 then
	    if mloc[2] > cardloc[i][2] and mloc[2] < cardloc[i][2] + 70 then
		spare=1
		if mstat=2 then   --this checks if the mouse is over a card
		    Change_cursor(1)   --(and changes the cursor)
		    mstat=1
		end if
	    end if
	end if
    end for
    
    if spare=0 then           --means the mouse is over nothing
	if mstat=1 then
	    Change_cursor(2)
	    mstat=2
	end if
    end if

end procedure

--MOUSECHECK-------------------------------------------------------------------

procedure mousecheck(sequence mloc)
    STICK=0              --checks where ya clicked da mouse (ya!!)
    HIT=0
    DEAL=0
    if mstat=1 then
     if mloc[1] > deckloc[1][1] and mloc[1] < deckloc[2][1] then
	if mloc[2] > deckloc[1][2] and mloc[2] < deckloc[2][2] then
	    if game=1 then
		HIT=1
	    else
		DEAL=1
	    end if
	else
	  if game=1 then
	      STICK=1
	  end if
	end if
     else
	if game=1 then
	    STICK=1
	end if
    end if
   end if
end procedure

--KEYCHECK()-------------------------------------------------------------------

procedure keycheck()        --checks what key ya hit (ADRIAN-N-N-N-N-N-N!!)
    STICK=0
    HIT=0
    DEAL=0
    if action[2] = ENTER then
	if game = 1 then
	    STICK=1
	end if
    end if
    if action[2] = SPACE then
	if game = 1 then
	    HIT=1
	else
	    DEAL=1
	end if
    end if
    if action[2] = ESC then
	endgame()
    end if
end procedure

--NEXTACTION()-----------------------------------------------------------------

function nextaction()
    
    spare={{},{}}
    
    while loop=1 do   --the never ending loop...
	
	spare[2]=get_key()  --check if a key was hit
	if spare[2] != -1 then
	    spare[1]=1
	    exit
	end if
	
	if mouse=1 then   --check if the mouse did anything
	    spare[2]=get_mouse()
	    if sequence(spare[2]) then
		if spare[2][1] = MOVE then
		    movemouse(spare[2][2..3])
		    spare={{},{}}
		elsif spare[2][1] = LEFT_UP or spare[2][1] = RIGHT_UP then
		    spare[1]=2
		    spare[2]=spare[2][2..3]
		    exit
		end if
	    end if
	end if
    
    end while
    return spare
end function

--SETUP()----------------------------------------------------------------------

procedure setup()          ----hmm... this sets the game up
  if mouse=1 then
    Change_cursor(2)
    mstat=2
  end if
  
  pwin=0
  plose=0
  spare=rand(3)             --randomly pick a .bmp file to use as the back of
  if spare = 1 then         --the card
    loadback("canada.bmp")
  elsif spare = 2 then
    loadback("fish.bmp")
  elsif spare = 3 then
    loadback("vegas.bmp")
  end if
		  --make the card table
  polygon(BRIGHT_GREEN,1,{{5,5},{5,460},{635,460},{635,5}})
  
  deck=shuffle(1)  --shuffle the deck  
  
  deckloc={{0,0},{0,0}}  --just to start it off as something
  
  deal()  --start the game!!!
end procedure

-------------------------------------------------------------------------------
--------------START OF GAME---------------------------------------------------
-------------------------------------------------------------------------------
loadcards(1)   --this should always be right at the beginning
	       --must use loadcards(0) if you plan on playing through a
	       --part-screen in Windows...

--ask the player if he/she has a mouse
--talking about "she", I wonder why there isn't many female Euphorians?
--(or any language, for that matter...)
--WHOAH!! Man I get off topic while I'm programming!!!
puts(1,"Do you have a mouse? (y/n)\n\n")
while loop=1 do
    spare=get_key()
    if spare=121 or spare=110 then
	exit
    end if
end while
if spare=121 then
    mouse=1
else
    mouse=0
end if

spare=graphics_mode(18)  --my favorite graphics mode... (640x320x16)

setup()

while loop=1 do         --this is where the rest of the game takes place
    action = nextaction()
    if action[1] = 1 then
	keycheck()
    else
	mousecheck(action[2])
    end if
    doaction()
end while

-------------------------------------------------------------------------------
-------------END OF PROGRAM----------------------------------------------------
-------------------------------------------------------------------------------
